/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.agentspeak.debugger;

import com.agentfactory.agentspeak.interpreter.AbstractAgentSpeakAgent;
import com.agentfactory.agentspeak.interpreter.Utilities;
import com.agentfactory.agentspeak.interpreter.mentalstate.ASEvent;
import com.agentfactory.agentspeak.interpreter.mentalstate.Commitment;
import com.agentfactory.agentspeak.interpreter.mentalstate.PlanRule;
import com.agentfactory.logic.update.interpreter.Action;
import com.agentfactory.logic.update.interpreter.Sensor;
import com.agentfactory.logic.update.lang.Predicate;
import com.agentfactory.visualiser.impl.DefaultSnapshot;
import com.agentfactory.visualiser.impl.DefaultStateManager;

/**
 *
 * @author remcollier
 */
public class AgentSpeakStateManager extends DefaultStateManager {
    @Override
    protected DefaultSnapshot createSnapshot() {
        return new AgentSpeakSnapshot();
    }
    
    @Override
    protected void constructSnapshot(DefaultSnapshot shot) {
        super.constructSnapshot(shot);
        
        AbstractAgentSpeakAgent agt = (AbstractAgentSpeakAgent) agent;
        AgentSpeakSnapshot snap = (AgentSpeakSnapshot) shot;
        
        if (agt.getEvent() != null) {
        	snap.event = agt.getEvent().toString();
        	for (PlanRule rule: agt.getOptions()) {
        		snap.options.add(rule.toString());
        	}
        	if (agt.getSelected() != null) snap.option = agt.getSelected().toString();
        }
        
        for (ASEvent event: agt.getEventQueue()) {
        	snap.events.add(event.toString());
        }
        for(Predicate bel: agt.getBeliefs()) {
        	snap.beliefs.add(Utilities.presenter.toString(bel));
        }
        
        for (Commitment commitment: agt.getCommitments()) {
        	snap.commitments.add(new CommitmentDescription(commitment));
        }
        
        snap.rules = agt.getRules();
        
		for (Action action: agt.getActions()) {
			snap.actions.add(new ComponentDescription(action.getId(), action.getClass().getName()));
		}
        
		for (Sensor sensor: agt.getSensors()) {
			snap.sensors.add(new ComponentDescription(sensor.getId(), sensor.getClass().getName()));
		}
    }
}
