package com.agentfactory.agentspeak.interpreter;

import com.agentfactory.agentspeak.interpreter.mentalstate.AchievementFormula;
import com.agentfactory.agentspeak.interpreter.mentalstate.StateUpdateFormula;
import com.agentfactory.agentspeak.interpreter.mentalstate.TestFormula;
import com.agentfactory.logic.update.lang.IFormula;
import com.agentfactory.logic.update.util.DefaultLogicPresenter;

public class AgentSpeakLogicPresenter extends DefaultLogicPresenter {
	public String toString(IFormula formula) {
		if (TestFormula.class.isInstance(formula)) {
			return "?" + toString(((TestFormula) formula).formula());
		} else if (StateUpdateFormula.class.isInstance(formula)) {
			StateUpdateFormula f = (StateUpdateFormula) formula;
			return ((f.updateType() == StateUpdateFormula.ADDITION) ? "+":"-") + toString(f.formula());
		} else if(AchievementFormula.class.isInstance(formula)) {
			return "@" + toString(((AchievementFormula) formula).formula());
		}
			
		return super.toString(formula);
	}
}
