/*
 * MentalAgent.java
 *
 * Created on 10 January 2006, 11:29
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
package com.agentfactory.logic;

import java.util.LinkedList;
import java.util.List;

import com.agentfactory.logic.agent.Module;
import com.agentfactory.logic.agent.OntologyManager;
import com.agentfactory.logic.agent.Perceptor;
import com.agentfactory.logic.agent.beliefManagement.IBeliefManager;
import com.agentfactory.logic.agent.beliefManagement.TemporalBeliefManager;
import com.agentfactory.logic.lang.FOS;
import com.agentfactory.logic.reasoner.QueryEngine;
import com.agentfactory.platform.impl.AbstractAgent;

/**
 *
 * @author Administrator
 */
public abstract class MentalAgent extends AbstractAgent {
    protected OntologyManager ontologyManager;
    protected List<Perceptor> perceptors;
    protected IBeliefManager beliefManager;
    protected QueryEngine queryEngine;

    public MentalAgent(String name)  {
        super(name);

        queryEngine = new QueryEngine();
        beliefManager = new TemporalBeliefManager(this, queryEngine);
        perceptors = new LinkedList<Perceptor>();
        //beliefManager = new PersistentBeliefManager(this);
        queryEngine.addSource(beliefManager);
        ontologyManager = new OntologyManager();
    }

    public void initialise(String content) {
        beliefManager.adopt(new FOS(content));
    }

    public IBeliefManager getBeliefManager() {
        return beliefManager;
    }

    public List<Perceptor> getPerceptors() {
        return perceptors;
    }
    
    public void adoptBelief(FOS belief) {
        beliefManager.adopt(belief);
    }
    
    public void dropBelief(FOS belief) {
        beliefManager.drop(belief);
    }
    
    public abstract Module getModuleByName(String name) ;
    
    public abstract Module getModuleByClass(String className) ;
    
    public OntologyManager getOntologyManager() {
        return ontologyManager;
    }
}
