/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.logic.agent;

import com.agentfactory.logic.lang.FOS;
import java.io.Serializable;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 *
 * @author remcollier
 */
public class Ontology implements Serializable {
    private String identifier;
    private Map<String, Predicate> predicateMap;
    private List<Predicate> predicates;
    private List<Function> functions;
    private Map<String, Function> functionMap;
    
    public Ontology(String identifier, List<Predicate> terms, List<Function> functions) {
        this.identifier = identifier;
        this.predicates = terms;
        this.functions = functions;
        predicateMap = new HashMap<String, Predicate>();
        for (Predicate term: terms) {
            predicateMap.put(term.getPredicate(), term);
        }
        functionMap = new HashMap<String, Function>();
        for (Function function:functions) {
            functionMap.put(function.getFunctor(), function);
        }
    }
    
    public FOS getPredicate(String predicate) {
        return predicateMap.get(predicate).toFOS();
    }
    
    public List<Predicate> getPredicates() {
        return predicates;
    }
    
    public String getIdentifier() {
        return identifier;
    }
    
    public List<Function> getFunctions() {
       return functions;
    }
}
