/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.logic.agent;

import com.agentfactory.logic.lang.FOS;
import java.io.Serializable;
import java.util.List;

/**
 *
 * @author remcollier
 */
public class Predicate implements Serializable {
    private String predicate;
    private List<String> variables;
    private List<String> types;
    
    /** Creates a new instance of tERM */
    public Predicate(String predicate, List<String> types, List<String> variables) {
        this.predicate = predicate;
        this.types = types;
        this.variables = variables;
    }
    
    public String getPredicate() {
        return predicate;
    }
    
    public String getType(int i) {
        return types.get(i);
    }
    
    public String getVariable(int i) {
        return variables.get(i);
    }
    
    public int numVariables() {
        return variables.size();
    }
    
    public FOS toFOS() {
        StringBuffer buf = new StringBuffer();
        buf.append(predicate);
        if (!variables.isEmpty()) {
            buf.append("(");
            boolean first = true;
            for (String variable:variables) {
                if (first) first = false;
                else buf.append(",");
                buf.append(variable);
            }
            buf.append(")");
        }
        return new FOS(buf.toString());
    }
    
    @Override
    public String toString() {
        StringBuffer buf = new StringBuffer();
        buf.append(predicate);
        if (!variables.isEmpty()) {
            buf.append("(");
            boolean first = true;
            for (int i=0;i<variables.size();i++) {
                if (first) first = false;
                else buf.append(",");
                buf.append(types.get(i) + ":" + variables.get(i));
            }
            buf.append(")");
        }
        return buf.toString();
    }
}
