package com.agentfactory.logic.agent.beliefManagement;

import com.agentfactory.logic.agent.*;
import com.agentfactory.logic.lang.FOS;
import com.agentfactory.logic.lang.TerImplication;
import java.util.List;

/**
 * A rule-based belief manager supports the storage and querying of beliefs
 * (facts) and belief rules (implications).
 * 
 * @author Rem Collier
 */
public class RuleBasedBeliefManager extends BasicBeliefManager {
    protected BeliefRuleStore beliefRules;
    
    public RuleBasedBeliefManager() {
        beliefRules = new BeliefRuleStore();
    }

    public void addBelief(TerImplication rule) {
        beliefRules.addRule(rule);
    }

    @Override
    public List query(FOS query) {
        List list = super.query(query);
        list.addAll(beliefRules.query(query));
        return list;
    }

    public List<TerImplication> getRules() {
        return beliefRules.getRules();
    }
}
