package com.agentfactory.logic.update.lang;

import java.util.LinkedList;
import java.util.List;
import java.util.Set;

import com.agentfactory.logic.update.reasoner.Bindings;

public class Tail implements ITerm {
	private ITerm term;
	
	public Tail(ITerm term) {
		this.term = term;
	}
	
	@Override
	public ITerm apply(Bindings set) {
		ITerm t = term.apply(set);
		if (ListTerm.class.isInstance(t)) {
			ListTerm list = (ListTerm) t;
			if (list.size()==0) return this;
			List<ITerm> terms = new LinkedList<ITerm>();
			for (int i=1;i<list.size(); i++) {
				terms.add(list.termAt(i));
			}
			return new ListTerm(terms);
			
		}
		return new Tail(t);
	}

	@Override
	public boolean containsVariable(Variable variable) {
		return term.containsVariable(variable);
	}

	@Override
	public boolean isCompatibleFunction(ITerm term) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isConstant() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isDistinctFunction(ITerm term) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isNotFunctional(ITerm term) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean hasTerms() {
		// Ignore this property for arithmetic
		// TODO (Rem Collier): Refactor this to be better...
		return false;
	}

	@Override
	public Set<Variable> getVariables() {
		return term.getVariables();
	}

	public boolean matches(ITerm t) {
		if (!Tail.class.isInstance(t)) {
			return false;
		}
		
		return term.matches(((Tail) t).term);
	}
	
	public ITerm getTerm() {
		return term;
	}
}
