/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.platform.impl;

import com.agentfactory.platform.core.IAgent;
import java.lang.reflect.Constructor;
import java.util.Properties;

/**
 *
 * @author remcollier
 */
public class JavaArchitectureFactory extends AbstractArchitectureFactory {
    private static final long DEFAULT_TIMESLICE = 100;
    
    private long timeSlice = DEFAULT_TIMESLICE;
    
    public IAgent create(String name, Object design) {
        // Check if we have a string based definition of the agent design...
        if (String.class.isInstance(design)) {
            // we have, so get the relevant class and recursively
            // call this method
            String theClass = (String) design;
            theClass = theClass.substring(0, theClass.lastIndexOf("."));
            try {
                return create(name, Class.forName(theClass));
            } catch (ClassNotFoundException ex) {
                return null;
            }
        }
        
        // Now try to instantiate the given class..
        Class agentClass = (Class) design;
        IAgent agent = null;
        Class[] types = { String.class };
        Object[] params = { name };
        try {
            Constructor constructor = agentClass.getConstructor(types);
            agent = (IAgent) constructor.newInstance(params);
            agent.setTimeSlice(timeSlice);
            return agent;
       } catch (Exception e) {
        }
        return null;
    }

    /**
     * This factory supports creation with a .java extension or creation using
     * Class objects.
     * 
     * @param design
     * @return
     */
    public boolean filter(Object design) {
        if (String.class.isInstance(design)) {
            return ((String) design).endsWith(".java");
        }
        return Class.class.isInstance(design);
    }

    @Override
    public void configure(Properties configuration) {
        super.configure(configuration);
        
        // Set timeslice
        String tSlice = configuration.getProperty("TIMESLICE");
        if (tSlice != null) {
            timeSlice = Long.parseLong(tSlice);
        }
    }
}
