package com.agentfactory.teleoreactive.core;

import com.agentfactory.logic.update.interpreter.Sensor;
import com.agentfactory.platform.core.IMessage;
import com.agentfactory.platform.impl.StringMessage;
import com.agentfactory.teleoreactive.interpreter.AbstractTeleoReactiveAgent;

public class InboxSensor extends Sensor {

	public void perceive() {
		for (IMessage message : agent.getInbox()) {
			if (message.getPerformative().equals("INFORM")) {
				((AbstractTeleoReactiveAgent) agent).addMessageBelief(message.getSender(),message.getContent());
			} else {
				StringMessage newmessage = StringMessage.newInstance();
				newmessage.setPerformative("NOT-UNDERSTOOD");
				newmessage.setSender(agent.getAgentID());
				newmessage.getReceivers().add(message.getSender());
				newmessage.setLanguage("AFAPL");
				newmessage.setOntology("none");
				newmessage.setProtocol("none");
				agent.send(message);
			}
		}
	}
}
